// ============================
// Working with Delphi records.
// ============================

// LMD Script Control allows you to work with Delphi records.
// Since COM model does not provide adequate record (struct)
// abstraction, script control uses special objects to represent
// record values inside script. As with any object, you must 
// create a record instance before it can be used. Use implicitly
// addded Create constructor for creating recor instances. Also use  
// implicitly added Copy method to make a record copy.
//
// Note: PascalScript suports native 'is' operator that not only 
//       allows to test object's class, but also allows to test
//       record type. So, there are no need to use RecIs function.

procedure Main;
var
  rec, recstr;
  samerec, anotherrec;
begin
    // Creating and using records:

    rec     := TPoint.Create;
    rec.X   := 3;
    rec.Y   := 5;
    recstr  := '(' + IntToStr(rec.X) + ', ' + IntToStr(rec.Y) + ')';

    MessageList.Lines.Add('Created TPoint record: ' + recstr);

    // Copying records:

    samerec    := rec;      // Just another ref to same record object.
    anotherrec := rec.Copy; // Real copy.

    // Record type testing:

    if rec is TPoint then
        MessageList.Lines.Add('Record is TPoint');

    if not (rec is TRect) then
        MessageList.Lines.Add('Record is not TRect');
end;

