// =================================
// Working with Delphi events.
// =================================

// LMD Script Control allows you to work with Delphi events.
// Script control uses special objects to represent event
// handler reference values inside script. 
//
// Note: PascalScript supports native '@' operator that allows 
//       to associate a script procedure with some event. So,
//       there are no need to use EventMake function.

procedure Main;
var
  form, btn;
begin
    form          := TForm.Create(Application);
    form.Caption  := 'LMD Script Control Events Demo';
    form.Position := poScreenCenter;
    form.OnClose  := @Form_Close;

    btn           := TButton.Create(form);
    btn.Left      := 20;
    btn.Top       := 20;
    btn.Parent    := form;
    btn.Caption   := 'Click me';
    btn.OnClick   := @Btn_Click;

    form.ShowModal;
end;

procedure Form_Close(Sender; var Action);
begin
    MessageList.Lines.Add('Form closed.');
end;

procedure Btn_Click(Sender);
begin
    MessageList.Lines.Add('Button clicked.');
end;
